/*****************************************************************************/
/* XMangekyou - a kaleidoscope for X                                         */
/* Programed by Sakai Hiroaki.                                               */
/*                                                                           */
/* Copyright (c) 1998 Sakai Hiroaki.                                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* XMangekyou is a kaleidoscope. You can see many, many, many patterns,      */
/* but, care for yourself from 'trip' filling!                               */
/*                                                                           */
/* XMangekyou is a free software. You may copy or distribute the original    */
/* XMangekyou freely. But, you may not modify or distribute the original     */
/* XMangekyou without permission of the author.                              */
/*****************************************************************************/

/*****************************************************************************/
/* Include Header Files.                                                     */
/*****************************************************************************/

#include<stdio.h>
#include<stdlib.h>

/*****************************************************************************/
/* Reading String.                                                           */
/*****************************************************************************/

int CheckSplitWord(int c)
{
  return ( (c == '\n') || (c == '\t') || (c == ' ') || (c == ',') );
}

int CheckCommentWord(int c)
{
  return ( (c == '#') || (c == '%') || (c == '$') || (c == '!' ) );
}

int CheckLineEnd(int c)
{
  return ( (c == '\n') || (c == EOF) );
}

int CheckQuotationWord(int c)
{
  return ( (c == '\"') || (c == '\'') );
}

int ReadString(FILE * fp, char * string)
{
  int c, i = 0;

  c = fgetc(fp);
  while (CheckSplitWord(c) || CheckCommentWord(c)) {
    while (CheckSplitWord(c)) c = fgetc(fp);
    while (CheckCommentWord(c)) while (!CheckLineEnd(c = fgetc(fp)));
  }
  if (CheckQuotationWord(c))
    while ( (!CheckQuotationWord(c = fgetc(fp))) && (!CheckLineEnd(c)) )
      string[i++] = (char)c;
  else do {
    string[i++] = (char)c;
    c = fgetc(fp);
  } while ( (!CheckSplitWord(c)) && (!CheckCommentWord(c)) &&
            (!CheckLineEnd(c)) );
  while (CheckCommentWord(c)) while (!CheckLineEnd(c = fgetc(fp)));
  string[i] = '\0';
  return (c);
}

int ReadInt(FILE * fp)
{
  char string[128];
  ReadString(fp, string);
  return (atoi(string));
}

signed char ReadChar(FILE * fp)
{
  char string[128];
  ReadString(fp, string);
  return ((signed char)atoi(string));
}

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
